<?php
require_once('/usr/local/www/berogui/includes/Helper/Helper.php');

$exec_submit = 1;
$invalid = array();

/* [CHECKING GET REQUEST] */
unset($_GET);

/* [CHECKING SESSION] */
$newTarget = '/app/berogui/index.php?m=Dialplan';
require_once('/usr/local/www/berogui/includes/session.php');
unset($newTarget);

/* [CHECKING POST] */
require_once('/usr/local/www/berogui/misc/config_parameter.php');
require_once('/usr/local/www/berogui/includes/Helper/HelperSip.php');
require_once('/usr/local/www/berogui/includes/Helper/HelperPstn.php');

unset($_POST['submit']);

// checking the from and to parameters and loading the corresponding parameters
$direction = array('sip', 'analog', 'isdn', 'cas', 'gsm', 'lte');
if (!Helper::checkInputData('select', $_POST['from'], $direction) || !Helper::checkInputData('select', $_POST['to'], $direction)) {
        echo "<script>window.location='../../index.php?m=Dialplan&error=1&request=POST&checkor=select'</script>";
	exit(1);
}

$general_pstn = HelperPstn::GetPostParameters('general');
$sip_post = HelperSip::GetPostParameters(get_sip_post_options()); 

$to_post   = $_POST['to']   === 'sip' ? array('post' => array(), 'options' => array()) : HelperPstn::GetPostParameters($_POST['to']  , get_pstn_post_options($_POST['to']  ));
$from_post = $_POST['from'] === 'sip' ? array('post' => array(), 'options' => array()) : HelperPstn::GetPostParameters($_POST['from'], get_pstn_post_options($_POST['from']));

$save_direction = array('from' => $_POST['from'], 'to' => $_POST['to']);
unset($_POST['from'], $_POST['to']);

// checking the default parameters and gathering the parameters
$post = array();
$post_def = array();
foreach ($_POST as $key => $value) {
	if (preg_match('/^def_*/', $key)) {
		$post_def[$key] = Helper::sanitizePost($value, 'bool', $exec_submit, $invalid);
	} else {
		$post[$key] = $value;
	}
}

// intern-more post variables
$more_popup = array(
			'post' 	  => array('page' => 'int>=0', 'dir' => 'direction', 'search' => 'int>=0'),
			'options' => array()
	           );

$post_params  = array_merge($general_pstn['post'], $sip_post['post'], $from_post['post'], $to_post['post'], $more_popup['post']);
$post_options = array_merge($general_pstn['options'], $sip_post['options'], $from_post['options'], $to_post['options'], $more_popup['options']);
$post = Helper::sanitizePost($post, $post_params, $exec_submit, $invalid, $post_options);

/* [EXECUTING SUBMIT] */
if (!$exec_submit) {
        echo "<script>window.location='../../index.php?m=Dialplan&error=1&request={$invalid['request']}&checkor={$invalid['checkor']}&key={$invalid['key']}'</script>";
	exit(1);
}

$_POST = array_merge($save_direction, $post_def, $post);

chdir("../..");
	include './includes/variables.php';
	include_once("/usr/www/include/SQLite2ToSQLite3.php");
	include './misc/database.php';
	$ba = new beroAri();
	require_once ('./includes/lang.php');
	//AJAX um die Haupseite zu aktualisieren
	echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">
<html>
<head>";


	//Liefert das endgültige Configstring
	function parameters($config,$from,$to){
		foreach ($_POST as $key=>$value){
			$_POST[$key]=str_replace("'","\"",$_POST[$key]);
		}
			//GSM clir
			if (!isset($_POST['def_gsm_clir'])){
				if (isset($_POST['gsm_clir']))
					$config.=",gsm_clir=".trim($_POST['gsm_clir']);
			}
			
			//EC
			if (!isset($_POST['def_ec'])){
				if (isset($_POST['ec']))
					$config.=",ec=".trim($_POST['ec']);
			}

			//ECTL
			if (!isset($_POST['def_ectl'])){
				if (isset($_POST['ectl']))
					$config.=",ectl=".trim($_POST['ectl']);
			}
			//DTON
			if (!isset($_POST['def_dton'])){
				if (isset($_POST['dton']))
					$config.=",dton=".trim($_POST['dton']);
			}

			//OTON
			if (!isset($_POST['def_oton'])){
				if (isset($_POST['oton']))
					$config.=",oton=".trim($_POST['oton']);
			}

			//BEARER
			if (!isset($_POST['def_bearer_cap'])){
				if (isset($_POST['bearer_cap']))
					$config.=",bearer_cap=".trim($_POST['bearer_cap']);
			}
			
			//SCREENING
			if (!isset($_POST['def_screen'])){
				if (isset($_POST['screen']))
					$config.=",screen=".trim($_POST['screen']);
			}
			//PRESENTATION
			if (!isset($_POST['def_pres'])){
				if (isset($_POST['pres']))
					$config.=",pres=".trim($_POST['pres']);
			}
			//CALL DEFLECTION
			if (!isset($_POST['def_cd'])){
				if (isset($_POST['cd']))
					$config.=",cd=".trim($_POST['cd']);
			}
			//T.38
			if (!isset($_POST['def_t38'])){
				if (isset($_POST['t38']))
					$config.=",t38=".trim($_POST['t38']);
			}
			//IE on SIP
			if (!isset($_POST['def_ie_on_sip'])){
				if (isset($_POST['ie_on_sip']))
					$config.=",ie_on_sip=".trim($_POST['ie_on_sip']);
			}

			//WAIT FOR CANCEL
			if (!isset($_POST['def_wait_for_cancel'])){
				if (isset($_POST['wait_for_cancel']))
					$config.=",wait_for_cancel=".trim($_POST['wait_for_cancel']);
			}
			//DTMF
			if (!isset($_POST['def_dtmfmode'])){
				if (isset($_POST['dtmfmode']))
					$config.=",dtmfmode=".trim($_POST['dtmfmode']);
			}
			//DTMF
			if (!isset($_POST['def_s2i_cpt'])){
				if (isset($_POST['s2i_cpt']))
					$config.=",s2i_cpt=".trim($_POST['s2i_cpt']);
			}
			//DTMF
			if (!isset($_POST['def_i2s_cpt'])){
				if (isset($_POST['i2s_cpt']))
					$config.=",i2s_cpt=".trim($_POST['i2s_cpt']);
			}
			//CODECS
			if (!isset($_POST['def_codecs'])){
				$c="";
				for ($i=0;$i<count($_POST['codecs']);$i++){
					if ($c!="") $c.=":";
					$c.= $_POST['codecs'][$i];
				}
				if (isset($_POST['codecs']) && $defc[$_POST['fromIdSip']]['codecs']!=$c)
					$config.=",codecs=".$c;
			}

			//ANALOG_OAD_SETTING
			if (!isset($_POST['def_analog_oad_setting'])){
				if (isset($_POST['analog_oad_setting']) && $_POST['analog_oad_setting']!='manual') $config.=",analog_oad_setting=".$_POST['analog_oad_setting'];
				else if (isset($_POST['analog_oad_setting']) && $_POST['analog_oad_setting']=='manual') $config.=",analog_oad_setting=".$_POST['analog_oad_setting_manual'];
			}

			//ANALOG_DISPLAY_SETTING
			if (!isset($_POST['def_analog_display_setting'])){
				if (isset($_POST['analog_display_setting']) && $_POST['analog_display_setting']!='manual') $config.=",analog_display_setting=".$_POST['analog_display_setting'];
				else if (isset($_POST['analog_display_setting']) && $_POST['analog_display_setting']=='manual') $config.=",analog_display_setting=".$_POST['analog_display_setting_manual'];
			}

			//FROM_PSTN_SRC_SETTING
			if ($from=="isdn" && $to=="analog"){
				if (!isset($_POST['def_from_pstn_src_setting_isdn'])) {
					if (strlen (trim($_POST['from_pstn_src_setting_isdn']))) {
						$config.=",from_pstn_src_setting=".$_POST['from_pstn_src_setting_isdn'];
					}
				}
				if (!isset($_POST['def_from_pstn_src_setting_analog']) && strpos($config,"from_pstn_src_setting")===false) {
					if (strlen (trim($_POST['from_pstn_src_setting_analog']))) {
						$config.=",from_pstn_src_setting=".$_POST['from_pstn_src_setting_analog'];
					}
				}
			}
			else{
				if (!isset($_POST['def_from_pstn_src_setting_analog'])) {
					if (strlen (trim($_POST['from_pstn_src_setting_analog']))) {
						$config.=",from_pstn_src_setting=".$_POST['from_pstn_src_setting_analog'];
					}
				}
				if (!isset($_POST['def_from_pstn_src_setting_isdn']) && strpos($config,"from_pstn_src_setting")===false) {
					if (strlen (trim($_POST['from_pstn_src_setting_isdn']))) {
						$config.=",from_pstn_src_setting=".$_POST['from_pstn_src_setting_isdn'];
					}
				}
			}
			
			//ISDN_OAD_SETTING
			if (!isset($_POST['def_isdn_oad_setting'])){
				if (isset($_POST['isdn_oad_setting']) && $_POST['isdn_oad_setting']!='manual') $config.=",isdn_oad_setting=".$_POST['isdn_oad_setting'];
				else if (isset($_POST['isdn_oad_setting']) && $_POST['isdn_oad_setting']=='manual') $config.=",isdn_oad_setting=".$_POST['isdn_oad_setting_manual'];
			}

			//ISDN_OAD2_SETTING
			if (!isset($_POST['def_isdn_oad2_setting'])){
				if (isset($_POST['isdn_oad2_setting']) && $_POST['isdn_oad2_setting']!='manual') $config.=",isdn_oad2_setting=".$_POST['isdn_oad2_setting'];
				else if (isset($_POST['isdn_oad2_setting']) && $_POST['isdn_oad2_setting']=='manual') $config.=",isdn_oad2_setting=".$_POST['isdn_oad2_setting_manual'];
			}

			//ISDN_QSIGNAME_SETTING
			if (!isset($_POST['def_isdn_qsigname_setting'])){
				if (isset($_POST['isdn_qsigname_setting']) && $_POST['isdn_qsigname_setting']!='manual') $config.=",isdn_qsigname_setting=".$_POST['isdn_qsigname_setting'];
				else if (isset($_POST['isdn_qsigname_setting']) && $_POST['isdn_qsigname_setting']=='manual') $config.=",isdn_qsigname_setting=".$_POST['isdn_qsigname_setting_manual'];
			}

			//ISDN_REDIRECTED_NR_SETTING
			if (!isset($_POST['def_isdn_redirected_nr_setting'])){
				if (isset($_POST['isdn_redirected_nr_setting']) && $_POST['isdn_redirected_nr_setting']!='manual') $config.=",isdn_redirected_nr_setting=".$_POST['isdn_redirected_nr_setting'];
				else if (isset($_POST['isdn_redirected_nr_setting']) && $_POST['isdn_redirected_nr_setting']=='manual') $config.=",isdn_redirected_nr_setting=".$_POST['isdn_redirected_nr_setting_manual'];
			}
			
			//ISDN_DAD_SETTING
			if (!isset($_POST['def_isdn_dad_setting'])){
				if (isset($_POST['isdn_dad_setting']) && $_POST['isdn_dad_setting']!='manual') $config.=",isdn_dad_setting=".$_POST['isdn_dad_setting'];
				else if (isset($_POST['isdn_dad_setting']) && $_POST['isdn_dad_setting']=='manual') $config.=",isdn_dad_setting=".$_POST['isdn_dad_setting_manual'];
			}

			//FROM_SIP_SRC_SETTING
			if (isset($_POST['from_sip_src_setting']) && $_POST['from_sip_src_setting'] != 'manual' && $_POST['from_sip_src_setting'] != $default['from_sip_src_setting']) {
				$config .= ",from_sip_src_setting=" . $_POST['from_sip_src_setting'];
			}
			else if (isset($_POST['from_sip_src_setting']) && $_POST['from_sip_src_setting'] == 'manual') {
				$config .= ",from_sip_src_setting=" . $_POST['from_sip_src_setting_manual'];
			}
			
			//FROM_SIP_DEST_SETTING
			if (isset($_POST['from_sip_dest_setting']) && $_POST['from_sip_dest_setting'] != 'manual' && $_POST['from_sip_dest_setting'] != $default['from_sip_dest_setting']) {
				$config .= ",from_sip_dest_setting=" . $_POST['from_sip_dest_setting'];
			}
			else if (isset($_POST['from_sip_dest_setting']) && $_POST['from_sip_dest_setting'] == 'manual') {
			
				$config .= ",from_sip_dest_setting=" . $_POST['from_sip_dest_setting_manual'];
			}
			
			//S2S_NAT_OPENER
			if (!isset($_POST['def_s2s_nat_opener'])){
				if (isset($_POST['s2s_nat_opener'])) $config.=",s2s_nat_opener=".$_POST['s2s_nat_opener'];
			}
			
			//S2S_RTP METHOD
			if (!isset($_POST['def_s2s_rtp_handling_method'])){
				if (isset($_POST['s2s_rtp_handling_method'])) $config.=",s2s_rtp_handling_method=".$_POST['s2s_rtp_handling_method'];
			}

			//USE_PRIVACY_HEADER
			if (!isset($_POST['def_use_privacy_header'])){
				if (isset($_POST['use_privacy_header'])) $config.=",use_privacy_header=".$_POST['use_privacy_header'];
			}

			//SIP_PAI_USER_SETTING
			if (!isset($_POST['def_sip_pai_user_setting'])){
				if (isset($_POST['sip_pai_user_setting']) && $_POST['sip_pai_user_setting']!='manual') $config.=",sip_pai_user_setting=".$_POST['sip_pai_user_setting'];
				else if (isset($_POST['sip_pai_user_setting']) && $_POST['sip_pai_user_setting']=='manual') $config.=",sip_pai_user_setting=".$_POST['sip_pai_user_setting_manual'];
			}

			//SIP_PPI_USER_SETTING
			if (!isset($_POST['def_sip_ppi_user_setting'])){
				if (isset($_POST['sip_ppi_user_setting']) && $_POST['sip_ppi_user_setting']!='manual') $config.=",sip_ppi_user_setting=".$_POST['sip_ppi_user_setting'];
				else if (isset($_POST['sip_ppi_user_setting']) && $_POST['sip_ppi_user_setting']=='manual') $config.=",sip_ppi_user_setting=".$_POST['sip_ppi_user_setting_manual'];
			}

			//SIP_CONTACT_USER_SETTING
			if (!isset($_POST['def_sip_contact_user_setting'])){
				if (isset($_POST['sip_contact_user_setting']) && $_POST['sip_contact_user_setting']!='manual') $config.=",sip_contact_user_setting=".$_POST['sip_contact_user_setting'];
				else if (isset($_POST['sip_contact_user_setting']) && $_POST['sip_contact_user_setting']=='manual') $config.=",sip_contact_user_setting=".$_POST['sip_contact_user_setting_manual'];
			}

			//SIP_TO_USER_SETTING
			if (!isset($_POST['def_sip_to_user_setting'])){
				if (isset($_POST['sip_to_user_setting']) && $_POST['sip_to_user_setting']!='manual') $config.=",sip_to_user_setting=".$_POST['sip_to_user_setting'];
				else if (isset($_POST['sip_to_user_setting']) && $_POST['sip_to_user_setting']=='manual') $config.=",sip_to_user_setting=".$_POST['sip_to_user_setting_manual'];
			}

			//SIP_FROM_USER_SETTING
			if (!isset($_POST['def_sip_from_user_setting'])){
				if (isset($_POST['sip_from_user_setting']) && $_POST['sip_from_user_setting']!='manual') $config.=",sip_from_user_setting=".$_POST['sip_from_user_setting'];
				else if (isset($_POST['sip_from_user_setting']) && $_POST['sip_from_user_setting']=='manual') $config.=",sip_from_user_setting=".$_POST['sip_from_user_setting_manual'];
			}

			//SIP_FROM_DISPLAY_SETTING
			if (!isset($_POST['def_sip_from_display_setting'])){
				if (isset($_POST['sip_from_display_setting']) && $_POST['sip_from_display_setting']!='manual') $config.=",sip_from_display_setting=".$_POST['sip_from_display_setting'];
				else if (isset($_POST['sip_from_display_setting']) && $_POST['sip_from_display_setting']=='manual') $config.=",sip_from_display_setting=".$_POST['sip_from_display_setting_manual'];
			}

                        //SIP_NATIONAL_CODE
			if (!isset($_POST['def_sip_national_code'])){
				if (isset($_POST['sip_national_code']))
					$config.=",sip_national_code=".trim($_POST['sip_national_code']);
			}

                        //SIP_INTERNATIONAL_CODE
			if (!isset($_POST['def_sip_international_code'])){
				if (isset($_POST['sip_international_code']))
					$config.=",sip_international_code=".trim($_POST['sip_international_code']);
			}

                        //ISDN2SIP_DESTINATION_NUMFORMAT
			if (!isset($_POST['def_isdn2sip_destination_numformat'])){
				if (isset($_POST['isdn2sip_destination_numformat']))
					$config.=",isdn2sip_destination_numformat=".trim($_POST['isdn2sip_destination_numformat']);
			}
                        //ISDN2SIP_SOURCE_NUMFORMAT
			if (!isset($_POST['def_isdn2sip_source_numformat'])){
				if (isset($_POST['isdn2sip_source_numformat']))
					$config.=",isdn2sip_source_numformat=".trim($_POST['isdn2sip_source_numformat']);
			}
                        //DIALPLAN_INTERNATIONAL_PREFIX
			if (!isset($_POST['def_dialplan_international_prefix'])){
				if (isset($_POST['dialplan_international_prefix']))
					$config.=",dialplan_international_prefix=".trim($_POST['dialplan_international_prefix']);
			}

                        //SIP2DIALPLAN_DAD_PREFIX_SETTING
			if (!isset($_POST['def_sip2dialplan_dad_prefix_setting'])){
				if (isset($_POST['sip2dialplan_dad_prefix_setting']))
					$config.=",sip2dialplan_dad_prefix_setting=".trim($_POST['sip2dialplan_dad_prefix_setting']);
			}

                        //SIP2DIALPLAN_OAD_PREFIX_SETTING
			if (!isset($_POST['def_sip2dialplan_oad_prefix_setting'])){
				if (isset($_POST['sip2dialplan_oad_prefix_setting']))
					$config.=",sip2dialplan_oad_prefix_setting=".trim($_POST['sip2dialplan_oad_prefix_setting']);
			}

                        //SRTP_MODE
			if (!isset($_POST['def_srtp_mode'])){
				if (isset($_POST['srtp_mode']))
					$config.=",srtp_mode=".trim($_POST['srtp_mode']);
			}

                        //SRTP_CRYPTO_SUITES
			if (!isset($_POST['def_srtp_crypto_suites'])){
				$c="";
				for ($i=0;$i<count($_POST['srtp_crypto_suites']);$i++){
					if ($c!="") $c.=":";
					$c.= $_POST['srtp_crypto_suites'][$i];
				}
				if (isset($_POST['srtp_crypto_suites']) && $defc[$_POST['fromIdSip']]['srtp_crypto_suites']!=$c)
					$config.=",srtp_crypto_suites=".$c;
			}


		//Additional config string hinzufügen.
		if ($_POST['addit_options']!="") $config.=",".str_replace(array("\r\n", "\n", "\r"),",",$_POST['addit_options']);
		//echo "<script>alert('".$config."')</script>";

		//Wenn der Configstring mit einem "," anfängt wird dieses gelöscht
		if (stripos($config,",")==0 && stripos($config,",")!==false)
		$config=substr_replace($config,'',0,1);
		return $config;

	}

	$page=$_POST['page'];
	$dir=$_POST['dir'];
	$search=$_POST['search'];
	//Wenn einen Eintrag bearbeitet wurde
	if ($_POST['id_upd']) {
			$id=$_POST['id_upd'];
			$config=parameters($config,$_POST['from'],$_POST['to']);
			$query_new = $ba->update("UPDATE dialplan SET config='".sqlite_escape_string ($config)."' WHERE id='".sqlite_escape_string($id)."'");

	}


		Helper::activate(1);
		if (!$ba->is_error()) {
			echo "<script>window.location='../../index.php?m=Dialplan&start=" . $page . "&dir=" . $dir . "&search=" . $search . "';</script>";
		} else {
			echo "<script>alert(\"" . $ba->error() . "\");</script>";
		}
?>
